vl(1)

NAME
vl - list version information

SYNOPSIS
vl    [ version binding options ] [ options ] [ names .. ]
vlog    [ version binding options ] [ options ] [
names .. ]

Options:
    [ -?1aAcCdFghlLOqQrRStuvx ] [ -help ] [ -all ] [ -attr attribute ] [ -cache ] [ -expand (or -xpon) ] [ -fast ] [ -format format string ] [ -intent ] [ -locked ] [ -locker ] [ -log ] [ -noexpand (or -xpoff) ] [ -p all|attribute name ] [ -version ]

DESCRIPTION

vl prints various information about an AtFS object repository. While its main operation is to list the contents of an object repository in a manner similar to ls(1), vl knows about many options that extract additional information about individual versions or version histories.

If vl is invoked without any name arguments, it simply prints the contents of the object repository, including files (busy versions) and directories in the current directory. Version objects in the object repository are represented as filenames with a bracketed version identification extension. Generally, vl tries to give the illusion, as were all the versions in the object repository regular files in the current directory. While busy versions - which are regular files - may be manipulated by all commands and tools that operate on files, version objects can only be manipulated by special tools (ShapeTools) that operate on the object repository. The tools that operate on the object repository, however, can also access regular files because these are also part of the object repository.

With the -h option given, vl prints out one information item per history rather than per version. Default output in this case is a list of history and directory names with the range(s) of available versions following in brackets.

If filenames are given as arguments to vl, similarly to ls(1) only information about these object histories will be printed. Object names may also be given in bound version notation, i.e. a notation that identifies a particular version of an object (e.g. mkattr.c[2.4]). It is also possible to use a previously assigned symbolic name rather than a numerical version identification (e.g. mkattr.c[tools-V4R3]). Make sure to escape the bracket symbols as these usually have meaning to the shell. For further version binding possibilities (the version binding options) see the vbind(1) manual page.

The program vlog prints the log-entry for specified objects. Log-entries usually describe the reason for a particular change to the design object that led to the creation of the specified revision(s).

OPTIONS
All options also available in the ls(1) programs are marked on the following list.

-?, -help
    Print short information about usage of this command.

-1 (ls)
    Force single column output.

-a (ls)
    List all entries, even those with a name beginning with a '.' and the 'AtFS' entry. This option is default when vl is called by the super user.

-all
    List all available information.

-attr attribute
    Print only information about objects that have the specified attribute with the given values. The attribute value match is done without attribute expansion, even if -expand is set. attribute may also be a standard attribute. For a complete list of standard attributes names see the vadm(1) manual page.

-A (ls)
    Same as -a, but '.', '..', and 'AtFS' are not listed.

-c (ls)
    Sort the list of printed entries by the time of last status change.

-cache
    List entries from the derived object cache too.

-C (ls)
    Force multi column output. This is default when printing just the entry names (no -l and no -p option) and output goes to a terminal.

-d (ls)
    With a directory name given as argument, list the directory itself rather than its contents.

-expand, -xpon
    Expand attribute values before printing. Attribute values may contain citations of other attributes, or they may start with a special character ('^', '!' or '*') indicating that they need some kind of processing to determine the real attribute value (see vattr(1) for details). With the -expand option given, all citations will be evaluated and the attribute will be evaluated if necessary.

-fast
    Fast operation. Suppresses reader/writer synchronisation on AtFS archive files and ignores non-standard attributes. In combination with -h (histories), a short output is generated, that lists only the names of all histories and not their version ranges.

-format format string
    Specify custom-format for information printed about objects. This is a simple report generation facility for the shapeTools toolkit. The format string can be any string, but typically contains attribute citations (see retrv). As shapeTools attribute citations use a syntax that contains dollar-characters, it is advisable, to specify format strings in single-quotes to prevent shell from trying to apply variable substitution.

    Format strings can contain simple layout specifications (`\n' for newline characters, and `\t' for tabs. `\\' is a single backslash.)

    The format of the output of vl -l could for example be specified as follows:

    vl -format '$__mode$ $__state$ $__author$ \ $__size$ $__mtime$ $__self$\n'

    While the example only illustrates use of standard attributes, it is in fact possible to use any object attribute (i.e. user-defined attributes) in the format specification.

-F (ls)
    Append a symbolic file type character to each name. Directories are marked with a `/', sockets with a `=', symbolic links with a `@', executable files with `*', and derived objects with a `$'. If the file is locked a `^' is additionally appended.

-g (ls)
    Print the group of the entry owner (...) .

-h  Print histories instead of versions. All versions with the same name are folded together to one printed entry. All version binding options (see vbind(1)) are ignored, when displaying histories.

-intent
    Print message of intention for change. An intention message can be set while retrieving a version using retrv with option -lock.

-l (ls)
    List in long format, giving mode, version state, author, size in bytes, the save date, and version identification. For busy versions the date field will contain the time of last modification rather than the save date. The status of a version is printed as: b for busy, s for saved, p for proposed, P for published, a for accessed, f for frozen, and $ for derived.

-lll
    Same as -l -locked -locker.

-locked
    Print only locked versions.

-locker
    Print the locker instead of the author and last locking date instead of last modification or save date.

-log
    Print the log entry for each version.

-L (ls)
    Follow symbolic links. If a given name is a symbolic link, list the object referenced by the link rather than the link itself.

-noexpand, -xpoff
    Do not expand attribute values. This is the default, except when the -format option is set. Check -expand or vattr(1) for more information on attribute expansion.

-O  Print the version owner instead of the author.

-p "all" | attribute name
    Print the value of the given attribute. With the string 'all' given as argument to the -p option, print all non standard attributes.

-q (ls)
    Replace all non graphic character by '?' before printing. This is the default when output goes to a terminal.

-Q  Quiet Flag. Suppress any output to standard output. Only error messages will be printed to standard error.

-r (ls)
    Reverse the order of the entries printed.

-R (ls)
    Operate recursively visiting all subdirectories encountered.

-S  Print version states verbosely.

-t (ls)
    Sort the list of printed entries by the modification time.

-u (ls)
    Sort the list of printed entries by time of last access.

-U  Show user identifications as user@domain rather than just the user name.

-v  Print versions. This is the default (counterpart to

-version
    Print only the version identification of this program.

-x (ls)
    Do multi-column output with the entries sorted across rather than down the page.

SEE ALSO
vattr(1), vbind(1)

BUGS
When using the version binding options -since and -before, the vl output may look confusing. -since and -before define a time interval for save dates but vl displays the date of last modification, which may be older than the save date.

'.' and '..' are always ignored when displaying versions.

Several Options are not available when displaying histories (-h option). These are: -all, -attr, -c, -format, -intent, -locked, -log, -n, -p, -R, -t, and -u.

The displayed group name (-g option) may be wrong for busy versions.

-noexpand does not work together with -format.

-q, and -F are not implemented.

AUTHOR
Original version by Uli.Pralle@cs.tu-berlin.de and Axel.Mahler@cs.tu-berlin.de.
Totally reimplemented by Andreas.Lampen@cs.tu-berlin.de.